<script lang="ts">
import Flash from "./FlashMessage.vue";
import * as cd from "@/lib/chordDictionary";

type ChordData = {
  name: string;
  voicing?: string;
};

type FlashData = {
  message: string;
  chordData: Array<ChordData>;
  duration?: number;
  key: number;
};

export default {
  components: {
    Flash,
  },
  data() {
    const flashes: Array<FlashData> = [];
    return {
      flashes,
      nextKey: 0,
    };
  },
  expose: ["addFlash", "addChordFlash"],
  methods: {
    addFlash(message: string, duration?: number) {
      this.flashes.unshift({
        message: message,
        chordData: [],
        duration: duration,
        key: this.nextKey++,
      });
    },
    addChordFlash(chordNames: Array<string>, duration?: number) {
      // parse chord names
      const chordData: Array<ChordData> = [];
      chordNames.forEach((chordName) => {
        chordData.push(cd.parseChordName(chordName));
      });
      this.flashes.unshift({
        message: "",
        chordData,
        duration: duration,
        key: this.nextKey++,
      });
    },
  },
};
</script>
<template>
  <div class="flashes">
    <transition-group name="flashes_tx">
      <Flash
        v-for="flashData in flashes"
        :key="flashData.key"
        :duration="flashData.duration"
        @on-hidden="
          const i = flashes.findIndex((flash) => {
            flash.key === flashData.key;
          });
          flashes.splice(i, 1);
        "
      >
        {{ flashData.message }}
        <span
          class="chord_name"
          v-for="(data, key) in flashData.chordData"
          :key="key"
        >
          {{ data.name }}
          <sup v-if="data.voicing !== undefined">{{ data.voicing }}</sup>
        </span>
      </Flash></transition-group
    >
  </div>
</template>
<style scoped>
.flashes {
  position: fixed;
  top: 5em;
  width: 100%;
  z-index: 10;
}

.flashes_tx-enter-active {
  transition: all 0.1s ease;
}
.flashes_tx-move,
.flashes_tx-leave-active {
  transition: all 0.4s ease;
}

.flashes_tx-enter-from,
.flashes_tx-leave-to {
  opacity: 0;
}

.flashes_tx-leave-active {
  margin-top: -58px;
}

.chord_name::after {
  content: " , ";
}
.chord_name:last-child::after {
  content: "";
}
</style>
